# cpr_job.hpp File Reference

`#include <string>`
`#include <vector>`
`#include <iosfwd>`
`#include <saga/saga/util.hpp>`
`#include <saga/saga/base.hpp>`
`#include <saga/saga/types.hpp>`
`#include <saga/saga/session.hpp>`
`#include <saga/saga/call.hpp>`
`#include <saga/saga/job.hpp>`
`#include <saga/saga/packages/cpr/config.hpp>`
`#include <saga/saga/detail/attribute.hpp>`
`#include <saga/saga/detail/permissions.hpp>`

Go to the source code of this file.

## Namespaces
namespace | saga
namespace | saga::cpr
namespace | saga::cpr::attributes
namespace | saga::cpr::metrics
## Classes
class | saga::cpr::job
| The job is a saga::job with additional checkpoint and recovery related methods. More...
## Enumerations
enum | saga::cpr::state { saga::cpr::Unknown = saga::job::Unknown, saga::cpr::New = saga::job::New, saga::cpr::Running = saga::job::Running, saga::cpr::Failed = saga::job::Failed, saga::cpr::Done = saga::job::Done, saga::cpr::Canceled = saga::job::Canceled, saga::cpr::Suspended = saga::job::Suspended, saga::cpr::Checkpointing = 6, saga::cpr::Recovering = 7 }
| The state is equivalent to the inherited saga::job::state, but adds the Checkpointing and Recovering state. More...
## Variables
char const *const | saga::cpr::metrics::checkpoint = "cpr_job.Checkpoint"
| Fires if the job gets a checkpoint request.
char const *const | saga::cpr::metrics::checkpointed = "cpr_job.Checkpointed"
| Fires if the job finishes a checkpoint request.
char const *const | saga::cpr::metrics::recover = "cpr_job.Recover"
| Fires if the job gets a recover request.
char const *const | saga::cpr::metrics::recovered = "cpr_job.Recovered"
| Fires if the job finishes a recover request.